; vPak 1.1 for mIRC 5.91, by Variant <variant@variantrealities.com>
; Used with permission.  All credit for these routines go to Variant.
; There were some very slight modifications for the integration into
; Q3SA. (Mostly renaming)
; Thanks Variant.

alias Q3SA.vPak {
    if ($left($1,1) == -) { var %Options = $1 | tokenize 32 $2- }
    if (e isin %Options) { var %FileIDs = $1 | tokenize 32 $2- }
    if (l isin %Options) { var %ListDest = $1 | tokenize 32 $2- }
    ;Parse command line for long filenames
    if (" isin $1-) { tokenize 34 $1- | set -u %vPakFile $1 | set -u %vPakPath $3 }
    else { set -u %vPakFile $1 | set -u %vPakPath $2- }
    if (!%vPakPath) && (!%Options) && (%vPakFile) {
        if (\ !isin %vPakFile) { set -u %vPakFile $+($mircdir,%vPakFile) }
        ;Q3SA.vPakG %vPakFile
        return
    }
    elseif (!%vPakPath) && (l !isin %Options) && (h !isin %Options) {
        Q3SA.Display vPak Syntax: /vPak [-puzdlehn] [File ID table] [Window|Hashtable] [filename.vpk] [Path] | return
    }
    if (\ !isin %vPakFile) { set -u %vPakFile $+($mircdir,%vPakFile) }
    if (\ !isin %vPakPath) { set -u %vPakPath $+($mircdir,%vPakPath) }
    if ($right(%vPakPath,1) != \) { set -u %vPakPath $+(%vPakPath,\) }
    if (p isin %Options) {
        ;Pack files up
        Q3SA.Display vPak: Working...
        if (h !isin %Options) {
            if (!$isdir(%vPakPath)) { Q3SA.Display vPak Error: No such directory %vPakPath | return }
            Q3SA.CreateList %vPakPath
        }
        ;File version is not used yet - it will be used if options are added to vPak files.
        var %FilePos = 20, %vPakFileVersion = 1.0
        .remove $+(",%vPakFile,")
        btrunc $+(",%vPakFile,") 20
        if ($hget(vPakFileList)) { hfree vPakFileList } | hmake vPakFileList 20
        var %Counter = 1
        Q3SA.mkpath $nofile(%vPakFile)
        ;Add files to the vPak archive, and create a new list with file locations
        while (%Counter <= $hget(vPakList,Total)) {
            hadd vPakFileList %Counter $iif($gettok($hget(vPakList,%Counter),1,32) != DIR,%FilePos) $gettok($hget(vPakList,%Counter),1,32) $gettok($hget(vPakList,%Counter),2-,32)
            if ($gettok($hget(vPakList,%Counter),1,32) != DIR) {
                AddFile %FilePos $gettok($hget(vPakList,%Counter),1,32) $+($hget(vPakList,Parent),\,$gettok($hget(vPakList,%Counter),2-,32))
                inc %FilePos $gettok($hget(vPakList,%Counter),1,32)
            }
            inc %Counter
        }
        ;Write file list to the end of the file, and the position of the start of the list to the beginning.
        Q3SA.WriteFileList %FilePos
        Q3SA.Display vPak: Created %vPakFile
        if (z isin %Options) {
            if ($isfile($+($scriptdir,ngzipn.dll))) { var %DLL = $dll($+($scriptdir,ngzipn.dll),zip,%vPakFile) | Q3SA.Display vPak: Compressed $nopath(%vPakFile) file to: $nopath($+(%vPakFile,.gz)) }
            else { Q3SA.Display vPak Error: ngzipn.dll unavailable. Please place it in the same directory as vpak.mrc and try again. }
            if (d isin %Options) { .remove $+(",%vPakFile,") | Q3SA.Display vPak: Removed $nopath(%vPakFile) }
        }
    }
    elseif (u isin %Options) || (l isin %Options) || (e isin %Options) {
        if ($right(%vPakFile,3) == .gz) { set -u %vPakFile $left(%vPakFile,-3) }
        if (z isin %Options) {
            if (!$isfile($+(%vPakFile,.gz))) { Q3SA.Display vPak Error: The gzipped file could not be found. | return }
            if ($isfile($+($scriptdir,ngzipn.dll))) { var %DLL = $dll($+($scriptdir,ngzipn.dll),unzip,%vPakFile) | Q3SA.Display vPak: Decompressed $nopath($+(%vPakFile,.gz)) file to: $nopath(%vPakFile) }
            else { Q3SA.Display vPak Error: ngzipn.dll unavailable. Please place it in the same directory as vpak.mrc and try again. | return }
        }
        if (!$isfile(%vPakFile)) { Q3SA.Display vPak Error: No such file %vPakFile | return }
        if (u isin %Options) {
            Q3SA.Display vPak: Working...
            var %Total = $Q3SA.ExtractFileList, %Counter = 1, %Line
            if (%Total == BadFile) { Q3SA.Display vPak Error: %vPakFile can not be opened because it is an old format. | return BadFile }
            while (%Counter <= %Total) {
                %Line = $hget(vPakFileList,%Counter)
                if ($gettok(%Line,1,32) == DIR) { if (n !isin %Options) { Q3SA.mkpath $+(%vPakPath,$gettok(%Line,2-,32)) } }
                else { Q3SA.mkpath $nofile($+(%vPakPath,$iif(n !isin %Options,$gettok(%Line,3-,32),$nopath($gettok(%Line,3-,32))))) | Q3SA.ExtractFile $gettok(%Line,1-2,32) $+(%vPakPath,$iif(n !isin %Options,$gettok(%Line,3-,32),$nopath($gettok(%Line,3-,32)))) }
                ;if ($dialog(vPak)) { vPakG.Update %Counter %Total }
                inc %Counter
            }
            Q3SA.Display vPak: Extracted all files from %vPakFile to %vPakPath
        }
        elseif (l isin %Options) {
            if ($left(%ListDest,1) == @) && (!$window(%ListDest)) { Q3SA.Display vPak Error: No such window %ListDest | return }
            elseif ($left(%ListDest,1) != @) && (!$hget(%ListDest)) { Q3SA.Display vPak Error: No such hash table %ListDest | return }
            if ($left(%ListDest,1) == @) { var %Add = aline -l %ListDest }
            else { var %Add = hadd %ListDest }
            var %Total = $Q3SA.ExtractFileList, %Counter = 1, %Line
            if (%Total == BadFile) { Q3SA.Display vPak Error: %vPakFile can not be opened because it is an old format. | return BadFile }
            while (%Counter <= %Total) {
                %Line = $hget(vPakFileList,%Counter)
                %Add $iif($gettok(%Add,1,32) == hadd,%Counter) $iif($gettok(%Line,1,32) == DIR,DIR $gettok(%Line,2-,32),$gettok(%Line,2,32) $gettok(%Line,3-,32))
                inc %Counter
            }
            Q3SA.Display vPak: Extracted file list to %ListDest $iif($gettok(%Add,1,32) == hadd,hash table.,window.)
        }
        elseif (e isin %Options) {
            Q3SA.Display vPak: Working...
            var %Total = $Q3SA.ExtractFileList,%TotalIDs = $hget(%FileIDs,0).item,%Counter = 1
            if (%Total == BadFile) { Q3SA.Display vPak Error: %vPakFile can not be opened because it is an old format. | return BadFile }
            while (%Counter <= %TotalIDs) {
                %Line = $hget(vPakFileList,$hget(%FileIDs,%Counter))
                if ($gettok(%Line,1,32) == DIR) { if (n !isin %Options) { Q3SA.mkpath $+(%vPakPath,$gettok(%Line,2-,32)) } }
                else { Q3SA.mkpath $nofile($+(%vPakPath,$iif(n !isin %Options,$gettok(%Line,3-,32),$nopath($gettok(%Line,3-,32))))) | Q3SA.ExtractFile $gettok(%Line,1-2,32) $+(%vPakPath,$iif(n !isin %Options,$gettok(%Line,3-,32),$nopath($gettok(%Line,3-,32)))) }
                ;if ($dialog(vPak)) { vPakG.Update %Counter %TotalIDs }
                inc %Counter
            }
            Q3SA.Display vPak: Extracted file IDs from hash table %FileIDs to %vPakPath
        }
        if (d isin %Options) { .remove $+(",%vPakFile,") | Q3SA.Display vPak: Removed $nopath(%vPakFile) }
    }
    hfree -w vPak*
}

alias -l Q3SA.h2d {
    ;hex2dec function
    var %Text, %Counter = 1
    while (%Counter <= $len($1)) { %Text = %Text $base($mid($1,%Counter,2),16,10,2) | inc %Counter 2 }
    return %Text
}
alias -l Q3SA.d2h {
    ;dec2hex function
    var %Text, %Counter = 1
    while (%Counter <= $numtok($1,32)) { %Text = %Text $base($gettok($1-,%Counter,32),10,16,2) | inc %Counter }
    return $remove(%Text,$chr(32))
}

alias -l Q3SA.ExtractFileList {
    ;Read file list to hash table
    if ($hget(vPakFileList)) { hfree vPakFileList } | hmake vPakFileList 20
    bread $+(",%vPakFile,") 0 20 &Header
    var %FilePos = $base($Q3SA.d2h($bvar(&Header,1,4)),16,10), %FileSize = $file(%vPakFile).size,%Counter = 1,%Len
    if ($bvar(&Header,11,1).text != $Q3SA.vPakFileVersion) { return BadFile }
    while (%FilePos < %FileSize) {
        bread $+(",%vPakFile,") %FilePos 1000 &Data
        %Len = $base($Q3SA.d2h($bvar(&Data,1,2)),16,10)
        hadd vPakFileList %Counter $bvar(&Data,3,%Len).text
        inc %FilePos $calc(%Len + 2)
        inc %Counter
    }
    return $calc(%Counter - 1)
}

alias -l Q3SA.WriteFileList {
    var %FilePos = $1, %vPakVersion = $Q3SA.vPakFileVersion
    bset &FilePos 1 $Q3SA.h2d($base(%FilePos,10,16,8))
    bwrite $+(",%vPakFile,") 0 4 &FilePos
    bwrite $+(",%vPakFile,") 10 1 %vPakVersion
    var %Counter = 1, %Len, %Line
    while (%Counter <= $hget(vPakList,Total)) {
        %Len = $len($hget(vPakFileList,%Counter))
        %Line = $hget(vPakFileList,%Counter)
        bset &Len 1 $Q3SA.h2d($base(%Len,10,16,4))
        bwrite $+(",%vPakFile,") %FilePos 2 &Len
        inc %FilePos 2
        bwrite $+(",%vPakFile,") %FilePos %Len %Line
        inc %FilePos %Len
        inc %Counter
    }
}

;Syntax: /ExtractFile <byte position> <size> <path to file to extract>
alias -l Q3SA.ExtractFile {
    if ($left($1,1) == -) { var %Options = $1 | tokenize 32 $2- }
    var %BytePos = 0,%BytesRead
    while (%BytePos < $2) {
        bread $+(",%vPakFile,") $calc($1 + %BytePos) 8192 &Bytes
        %BytesRead = $iif($calc(%BytePos + 8192) < $2,8192,$calc($2 - %BytePos))
        bwrite $+(",$3-,") %BytePos %BytesRead &Bytes
        inc %BytePos %BytesRead
    }
}

;Syntax: /AddFile <byte position> <size> <path to file to add>
alias -l Q3SA.AddFile {
    var %BytePos = 0,%BytesRead
    while (%BytePos < $2) {
        bread $+(",$3-,") %BytePos 8192 &Bytes
        %BytesRead = $iif($calc(%BytePos + 8192) < $2,8192,$calc($2 - %BytePos))
        bwrite $+(",%vPakFile,") $calc($1 + %BytePos) %BytesRead &Bytes
        inc %BytePos %BytesRead
    }
}

;Syntax: /CreateList <Path>
alias -l Q3SA.CreateList {
    if ($hget(vPakList)) { hfree vPakList } | hmake vPakList 20
    !window -hl @vPakList
    var %ListCounter = 1, %Counter = 1, %Total = $finddir($1-,*,@vPakList)
    while (%Counter <= %Total) {
        var %Line = $line(@vPakList,%Counter,1)
        hadd vPakList %ListCounter DIR $remove(%Line,$1-)
        inc %ListCounter | inc %Counter
    }
    clear -l @vPakList
    var %Counter = 1, %Total = $findfile($1-,*.*,@vPakList)
    while (%Counter <= %Total) {
        var %Line = $line(@vPakList,%Counter,1)
        hadd vPakList %ListCounter $file(%Line).size $remove(%Line,$1-)
        inc %ListCounter | inc %Counter
    }
    !window -c @vPakList
    hadd vPakList Parent $1-
    hadd vPakList Total $calc(%ListCounter - 1)
}

alias -l Q3SA.mkpath {
    var %counter = 1
    while (%counter <= $numtok($1-,92)) {
        if (!$isdir($gettok($1-,$+(1-,%counter),92))) { Q3SA.mkdir $+(",$gettok($1-,$+(1-,%counter),92),") }
        inc %counter
    }
}
alias -l Q3SA.noext { return $gettok($1-,$+(1-,$calc($numtok($1-,46) - 1)),46) }
alias -l Q3SA.Display {
    if ($mtsversion) { set -u %:echo echo $color(info) -qa | set -u %::text $1- | theme.text Echo }
    else { echo $color(info) -qa *** $1- }
}

alias -l Q3SA.vPakVersion { return 1.1 }
alias -l Q3SA.vPakFileVersion { return 2 }
